
const complotDB = require('../database/ComplotDB.js');
const {Category} = require('../database/Category.js');

class CommandQui{
    constructor(client){
        this.client = client;
        this.sentences = ["Sûrement <who>...", "<who>", "<who> !", "<who> ??", "Vous parlez de <who> ?", "C'est <who>.", "Bah, <who>.", "Bah <who> connard", "Mmmh <who> ?", "<who> ?", "<who>, on te parle"];
        this.quiRegExp = new RegExp('([^a-z]|^)qui[^a-z]', 'i'); /**'qui' pas dans un mot */
    }

    getRandomQui(){
        const actor = complotDB.getRandom(Category.ACTOR);

        return this.sentences[Math.floor(Math.random()*this.sentences.length)].replace('<who>', actor);
    }

    parse(message){
        if(this.shouldRespond(message)){
            message.reply(this.getRandomQui());
        }
    }

    shouldRespond(message){
        const resRE = message.content.match(this.quiRegExp);
        if(resRE){
            return message.content.slice(resRE.index).includes('?'); /**Contient un '?'  après le ' qui ' */
        }
        return false;
    }
}

module.exports = CommandQui;