const channelsID = require('../channels_conf.json');
const complotDB = require('../database/ComplotDB.js');
const {Category} = require('../database/Category.js');


class VoteParser{
    
    constructor(client, baseInfo){
        this.baseInfo = baseInfo;
        this.client = client;
        this.upVote = '👍';
        this.score = 3;
        this.categories = new Map([
            [channelsID.actor, Category.ACTOR],
            [channelsID.reason, Category.REASON],
            [channelsID.action, Category.ACTION],
            [channelsID.source, Category.SOURCE],
            [channelsID.sentence, Category.SENTENCE]
        ]);
    }


    setScore(score) {
        this.score = score;
    }

    parse(message){
        if(message.author.id === this.client.application.id){
            return;
        }
        if(this.categories.has(message.channelId)){
            const category = this.categories.get(message.channelId);
            const reactions = message.reactions.resolve(this.upVote);
            if(reactions && reactions.count >= this.score){
                this.add(message, category);
            }
        }
    }

    categoryCase(category, content){
        if(category === CATEGORY.SOURCE || category === CATEGORY.SENTENCE){
            return content;
        }

        const char = content.charAt(0);
        const reste = content.slice(1);
        content = (category === CATEGORY.ACTOR) ? char.toUpperCase() + reste: char.toLowerCase() + reste;
        return content;
    }

    async add(message, category){
        let content = this.categoryCase(category, message.content);
        
        complotDB.add(category, messageString)

        message.delete();
        message.channel.send(`"${content}" ajouté ! \n Par <@${message.author.id}>`);
        
        this.baseInfo.updateBase(category);
    }
}

module.exports = VoteParser;
